/* 
 * Auteur : Fares BELHADJ (Lire COPYING)
 * Email  : amsi@ai.univ-paris8.fr
 * Date   : 06/12/2010
 */

#include "image.h"
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

/*
 * Fonction permettant de lire un fichier bmp 24 bits (rgb)
 * avec une seule couche (layer)
 */
extern int loadBMP(char * filename, image_t * image) { 
  FILE * file;
  unsigned long size, i;
  unsigned short int planes, bpp;
  if ((file = fopen(filename, "rb")) == NULL) {
    printf("Erreur fichier : %s\n", filename);
    return 0;
  }
  fseek(file, 18, SEEK_CUR);
  if ((i = fread(&image->w, 4, 1, file)) != 1) {
    printf("Erreur de lecture de la largeur.\n");
    return 0;
  }
  if ((i = fread(&image->h, 4, 1, file)) != 1) {
    printf("Erreur de lecture de la hauteur.\n");
    return 0;
  }
  size = image->w * image->h * 3;
  if ((fread(&planes, 2, 1, file)) != 1) {
    printf("Erreur de recuperation du nombre de couches.\n");
    return 0;
  }
  if (planes != 1) {
    printf("Nombre de couches non gere.\n");
    return 0;
  }
  if ((i = fread(&bpp, 2, 1, file)) != 1) {
    printf("Erreur de recuperation du depth.\n");
    return 0;
  }
  if (bpp != 24) {
    printf("Depth different de 24 non gere.\n");
    return 0;
  }
  fseek(file, 24, SEEK_CUR);
  image->data = malloc(size * sizeof * image->data);
  assert(image->data);
  if ((i = fread(image->data, size, 1, file)) != 1) {
    printf("Erreur de lecture des donnees.\n");
    return 0;
  }
  return 1;
}
